PlotPrinComp<-function(T,Y,cperc,type="covariance")
{
  perc<-c(cperc[1],diff(cperc))
  pca2.df<-data.frame(PC1=Y[,1],PC2=Y[,2],label=rownames(Y),
                      type=rep(type,nrow(Y)))
  label<-paste("PCA from ",type," matrix (",cperc[2],"%)",sep="")
  pca2.df$type<-factor(pca2.df$type,levels=rev(levels(pca2.df$type)),
                       labels=label)
  p2<-ggplot(data=pca2.df,aes(x=PC1,y=PC2))
  p2<-p2+geom_point()+facet_wrap(~type,scales="free",ncol=1)+
  scale_y_continuous("2nd Principal Component")+
  scale_x_continuous("1st Principal Component")
  p2 <- p2 + geom_text(data=pca2.df, hjust=+0.5,vjust=-0.5, 
                    aes(x=PC1, y=PC2, label=label), size=4) +theme_bw() 
  scree.df<-data.frame(index=1:ncol(T),percent=perc,type=rep(type,nrow(T)))
  label=paste("Scree graph from ",type," matrix",sep="")  
  scree.df$type<-factor(scree.df$type,levels=rev(levels(scree.df$type)),
                        labels=label)
  s<-ggplot(data=scree.df,aes(x=index,y=percent))
  s<-s+geom_point(size=4)+geom_line()+facet_wrap(~type,scales="free",ncol=1) 
  s<-s+scale_x_continuous("Principal Components")
  s<-s+ scale_y_continuous("Percentage of explained variability")+theme_bw()
  list(p=p2,s=s)
}  
