PrinCompCov<-function(X)
{
  ###############covariance-based results
  #auxilary routine to find covariance matrix of a column-centered X
  my.cov<-function(X){
   X=as.matrix(X);t(X)%*% scale(diag(nrow(X)),scale=FALSE)%*%X/nrow(X)}
  #obtain cov matrix, eigen values and vectors
  S<-my.cov(X)
  outS<-eigen(S)
  T1<-outS$vectors
  D1<-outS$values
  #correct the signs in columns of T1
  if((sum(sign(T1[,1])) < 0))
    T1<-sweep(T1,2,FUN="*", rep(-1,ncol(T1))^(1:ncol(T1)) )
  if( (sum(sign(T1[,2])) < 0))
    T1<-sweep(T1,2,FUN="*", rep(-1,ncol(T1))^(1+(1:ncol(T1)) ) )
  #reconstruct (center columns in X) 
  Y1<-as.matrix(scale(X,scale=FALSE))%*%T1
  #get the %s
  perc1<-round(100*D1/sum(D1),4)
  cperc1<-cumsum(perc1)
  rownames(Y1)<-rownames(X)
  list(T=T1,Y=Y1,cperc=cperc1)
}
