# This Rscript shows how to generate all the figures 
# and tables of the chapter
# Main directory: Files
# Sub directories: Data, Figures
dir="L:/Research/Aurea/Book/Files/"
setwd(dir)
library(ggplot2)
######################################Figure 1
name<-'Data/table1.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCov<-PrinCompCov(X)
X<-as.matrix(scale(X,scale=FALSE))
T<-outCov$T
Y<-outCov$Y
cperc<-outCov$cperc
#scatterplot of X2 versus X1
xlim<-c(-12,12)
ylim<-xlim
data.df<-data.frame(X1=X[,1],X2=X[,2],label=rownames(X))
d<-ggplot(data=data.df,aes(x=X1,y=X2))
d<-d+geom_abline(intercept=0, slope=1,size=1)+geom_point(size=4)+
  scale_y_continuous(expression(X[2]),limits=ylim)+
  scale_x_continuous(expression(X[1]),limits=xlim)
d <- d + geom_text(data=data.df, hjust=+0.5,vjust=-0.5, 
                     aes(x=X1, y=X2, label=label), size=4) +theme_bw() 
d<-d+ opts(axis.line = theme_segment(colour = 'grey', size = 1, linetype = 'solid'))
pca.df<-data.frame(Y1=Y[,1],Y2=Y[,2],label=rownames(Y))
p<-ggplot(data=pca.df,aes(x=Y1,y=Y2))
p<-p+geom_abline(intercept=0, slope=0,size=1)+geom_point(size=4)+
  scale_y_continuous(expression(Y[2]),limits=ylim)+
  scale_x_continuous(expression(Y[1]),limits=xlim)
p <- p + geom_text(data=pca.df, hjust=+0.5,vjust=-0.5, 
                   aes(x=Y1, y=Y2, label=label), size=4) +theme_bw() 

p<-p+ opts(axis.line = theme_segment(colour = 'grey', size = 1, linetype = 'solid'))
#saving plots
graphics.off()
postscript("Figures/fig1.eps",height=3.5,width=7,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(d, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(p, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()
######################################Figure 2
name<-'Data/table3.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCor<-PrinCompCor(X)
T<-outCor$T
Y<-outCor$Y
cperc<-outCor$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="correlation")
#saving plots
graphics.off()
postscript("Figures/fig2.eps",height=3.25,width=3.25,horizontal=FALSE)
#grid.newpage()
#pushViewport(viewport(layout = grid.layout(1, 1)))
#print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s)
dev.off()
######################################Figure 3
name<-'Data/table2.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCor<-PrinCompCor(X)
T<-outCor$T
Y<-outCor$Y
cperc<-outCor$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="correlation")
#saving plots
graphics.off()
postscript("Figures/fig3.eps",height=4,width=8,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(outPlot$p, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()
######################################Figure 4
name<-'Data/table3.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCor<-PrinCompCor(X)
T<-outCor$T
Y<-outCor$Y
cperc<-outCor$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="correlation")
#saving plots
graphics.off()
postscript("Figures/fig4.eps",height=4,width=8,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(outPlot$p, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()
######################################Figure 5
name<-'Data/table5.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCov<-PrinCompCov(X)
T<-outCov$T
Y<-outCov$Y
cperc<-outCov$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="covariance")
#saving plots
graphics.off()
postscript("Figures/fig5.eps",height=4,width=8,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(outPlot$p, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()
######################################Figure 8
name<-'Data/table9.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCor<-PrinCompCor(X)
T<-outCor$T
Y<-outCor$Y
cperc<-outCor$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="correlation")
#saving plots
graphics.off()
postscript("Figures/fig8.eps",height=4,width=8,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(outPlot$p, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()
#regresion line
response<-c(4.8,7.7,5.6,6.1,5.5,1.9)
outreg<-lm(y~Y[,1]+Y[,2])
######################################
######################################
######################################
######################################
######################################
######################################Table 6
name<-'Data/table5.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outdimtest<-dimtest(X)
######################################Table 7, Figure 6
name<-'Data/table2.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]

outPrinCor<-PrinCompCor(X)$T
outPrinStab01<-PrinCompStability(X,alpha=0.01)$TpR
outPrinStab05<-PrinCompStability(X,alpha=0.05)$TpR
outPrinStab10<-PrinCompStability(X,alpha=0.10)$TpR

stab.df<-data.frame(eigen=c(outPrinCor[,1],outPrinStab01[,1],
                          outPrinStab05[,1],outPrinStab10[,1],
                            outPrinCor[,2],outPrinStab01[,2],
                            outPrinStab05[,2],outPrinStab10[,2],                            
                            outPrinCor[,3],outPrinStab01[,3],
                            outPrinStab05[,3],outPrinStab10[,3]),
                    coeffs=rep(1:4,ncol(X)*(ncol(X)-1)),
                    Perturbation=rep(rep(c("a","b","c","d"),
                                         each=ncol(X)),ncol(X)-1),
                    PC=rep(c("1","2","3"),each=4*ncol(X)))
label<-c("0%","1%","5%","10%")
stab.df$Perturbation<-factor(stab.df$Perturbation,
                             levels=(levels(stab.df$Perturbation)),labels=label)
s<-ggplot(data=stab.df,aes(x=coeffs,y=eigen,linetype=Perturbation,
                           colour=PC))
s<-s+geom_line(size=0.8)+scale_y_continuous("Coefficients",limits=c(-1,1))+
                       scale_x_continuous("Principal Components")+theme_bw()
s<-s+ opts(legend.position="none")
text.df<-data.frame(eigen=c(0.55,-0.8,-0.5),
              coeffs=c(1.55,1.5,3),label=c("1st PC","2nd PC","3rd PC"),
                    Perturbation=rep("0%",3),PC=rep("1",3))
s <- s + geom_text(data=text.df,aes(x=coeffs, y=eigen, label=label), size=4) 
s<-s+scale_colour_manual(name=NULL, values=c("black","black","black"))
s<-s+scale_linetype_manual(name=NULL, 
           values=c("solid","dashed","dotdash","dotted"))
#saving plots
graphics.off()
postscript("Figures/fig6.eps",height=3.25,width=3.25,horizontal=FALSE)
#grid.newpage()
#pushViewport(viewport(layout = grid.layout(1, 1)))
#print(s, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(s)
dev.off()















######################################Figure 3 old top
name<-'Data/table2.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCov<-PrinCompCov(X)
T<-outCov$T
Y<-outCov$Y
cperc<-outCov$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="covariance")
#saving plots
graphics.off()
postscript("Figures/fig3top.eps",height=4,width=8,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(outPlot$p, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()
######################################Figure 4 old top
name<-'Data/table3.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCov<-PrinCompCov(X)
T<-outCov$T
Y<-outCov$Y
cperc<-outCov$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="covariance")
#saving plots
graphics.off()
postscript("Figures/fig4top.eps",height=4,width=8,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(outPlot$p, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()
######################################Figure 8 old top
name<-'Data/table9.txt'
Y=read.table(name,header=TRUE)
X<-as.matrix(Y[,2:ncol(Y)])
rownames(X)<-Y[,1]
outCov<-PrinCompCov(X)
T<-outCov$T
Y<-outCov$Y
cperc<-outCov$cperc
outPlot<-PlotPrinComp(T,Y,cperc,type="covariance")
#saving plots
graphics.off()
postscript("Figures/fig8top.eps",height=4,width=8,horizontal=FALSE)
grid.newpage()
pushViewport(viewport(layout = grid.layout(1, 2)))
print(outPlot$p, vp = viewport(layout.pos.row = 1, layout.pos.col = 1))
print(outPlot$s, vp = viewport(layout.pos.row = 1, layout.pos.col = 2))
dev.off()

